#!/bin/sh
[ $# -lt 1 ] && echo "error params" && exit 0
Session=$1
SESSION=$Session
SERVER=~/.kylin-ide-server
TOKENFILE=$SERVER/data/.$SESSION.token
SERVERPATH=$SERVER/server/package.json
SVERSION=$SERVER/server/sversion
APTPATH=/etc/apt
ALLRUNNINGPIDSUM=$(ps -uxww | grep  server-main.js | grep -v grep | wc -l)
RUNNINGPID=$(ps -uxww | grep $SESSION | grep  server-main.js | grep -v grep |wc -l)
SSL=$(ps -uxww | grep $SESSION | grep  server-main.js | grep -v grep |grep ssl| wc -l)
SSL_FLAGS=0
[ $SSL -ge 1 ] && SSL_FLAGS=1
arch=$(uname -m)
InternentVersion="0"
os=""
if [ -f /etc/.kyinfo ];then
	# name=$(cat /etc/.kyinfo | grep name |  awk -F '=' '{print $2}' | tr A-Z a-z)
	_os=$(cat /etc/.kyinfo | grep dist_id |  awk -F '=' '{print $2}' | awk -F "-${arch}" '{print $1}' | tr A-Z a-z)
	os="$_os"
else
	[ -d /etc/apt ] && type="desktop" || type="server"
	_os=$(cat /etc/os-release | grep "PRETTY_NAME" |sed 's/"//g' | awk -F '=' '{print $2}' | sed 's/ /./g' | tr A-Z a-z)
	os="$type.$_os"
fi
[ -n "$(echo $os |grep kylin)" ] && iskylin=1 || iskylin=0
if [ -e "$SVERSION" ];then
	serverversion=$(cat $SVERSION)
else
	[ -e "$SERVERPATH" ]  && serverversion=$(cat $SERVERPATH |grep "IDEVersion" |awk '{print $2}'|sed 's/"//g') || serverversion="0"
fi
if [ $iskylin -eq 1 ]; then
    [ -d "$APTPATH" ] && InternentVersion=$(apt-cache show 'kylin-ide-server' 2>&1 |grep -Po 'Version: \K.*' || echo "0")
else
    InternentVersion="0"
fi
WEB_SERVER_PATH=$SERVER/server/node
test -f $WEB_SERVER_PATH && ready=1 || ready=0
[ -n "$RUNNINGPID" ] && if [ $RUNNINGPID -gt 0 ];then
    [ $ALLRUNNINGPIDSUM -gt $RUNNINGPID ] && otherusing=1 || otherusing=0
    [ -e  $TOKENFILE ] && token=$(cat $TOKENFILE) || token=""
cat <<EOF
{"arch": "$arch","os": "$os","isrunning":1,"otherusing":$otherusing,"token":"$token","ready":$ready,"version":"$serverversion","SourceVerson":"$InternentVersion","ssl":$SSL_FLAGS,"display":"$DISPLAY"}
EOF
    exit 0
fi
[ $ALLRUNNINGPIDSUM -ge 1 ] && otherusing=1 || otherusing=0
cat <<EOF
{"arch": "$arch","os": "$os","isrunning":0,"otherusing":$otherusing,"ready":$ready,"version":"$serverversion","SourceVerson":"$InternentVersion","display":"$DISPLAY"} 
EOF
exit 0

