#!/bin/bash
hash=$1
port=$2
ssl=$3
islocal=$4
id=$5
SERVER=~/.kylin-ide-server
SERVER_DATA=$SERVER/data
HASHKEY=$hash
TRANSPORT=$port
SERVER_CRETDIR=$SERVER_DATA/$HASHKEY
[ -d $SERVER_DATA ] || mkdir $SERVER_DATA
SERVER_BIN=$SERVER/server/bin/kylin-ide-server
LOGFILE=$SERVER_DATA/$HASHKEY.log
TOKEN=$(cat /proc/sys/kernel/random/uuid)
echo $TOKEN >$SERVER_DATA/.$HASHKEY.token
ssl_param=""
sockparm=""
if [ $ssl == 'true' ] ;then 
    [ -d $SERVER_CRETDIR ] || mkdir $SERVER_CRETDIR
    # printf "%b\n" "$keypem" >$SERVER_CRETDIR/kylinideteam.key
    # printf "%b\n" "$certperm" > $SERVER_CRETDIR/kylinideteam.pem
    if [ -f "$SERVER/.kylinideteam.key" ] ;then 
        cp "$SERVER/.kylinideteam.key" "$SERVER_CRETDIR/kylinideteam.key"
    fi
    if [ -f "$SERVER/.kylinideteam.pem" ] ;then 
        cp "$SERVER/.kylinideteam.pem" "$SERVER_CRETDIR/kylinideteam.pem" 
    fi
    chmod 0600 $SERVER_CRETDIR/kylinideteam.key
    chmod 0600 $SERVER_CRETDIR/kylinideteam.pem
    ssl_param="--ssl --cert $SERVER_CRETDIR/kylinideteam.pem --key $SERVER_CRETDIR/kylinideteam.key"
fi
[ -e $SERVER_DATA/.$HASHKEY.sock ] && rm -rf $SERVER_DATA/.$HASHKEY.sock
if [ $islocal == 'true' ];then
    sockparm="--port $TRANSPORT"
else
    sockparm="--socket-path=$SERVER_DATA/.$HASHKEY.sock"
fi
$SERVER_BIN  $sockparm --remotename=$id $ssl_param --connection-token-file=$SERVER_DATA/.$HASHKEY.token --server-data-dir=$SERVER --enable-remote-auto-shutdown  > $LOGFILE  2>&1 & 
sleep 2
LOG_CONTEXT=$(cat $LOGFILE)
if echo "$LOG_CONTEXT" | grep -q "Server bound to";then
cat <<EOF
{"token":"$TOKEN","code":0,"log":""}
EOF
else
cat <<EOF
{"token":"","code":1,"log":"$LOG_CONTEXT"}
EOF
fi