#!/bin/bash
serverArch=$(arch)
usr_dir="/usr/local/kylin-ide-server/"
download_dir="/tmp/kylin-ide-server/"
PACKAGENAME="kylin-ide-server"
if [ ! -d "$download_dir" ];then
    mkdir -p "$download_dir"
fi
rm -rf ~/.kylin-ide-server/server ~/.kylin-ide-server/data
mkdir -p ~/.kylin-ide-server/server 
lastserverfile=""
search_dir=$usr_dir
if [[ "$serverArch" == "x86_64" || "$serverArch" == "aarch64" || "$serverArch" == "loongarch64" ]];then
    if [ -d "$search_dir" ];then
        lastserverfile=$(ls "$search_dir" |grep "kylin-ide-server_[0-9]\+\.[0-9]\+\.[0-9]\+_${serverArch}.tar.gz"  |sort -V |tail -n 1)
    fi
    if [[ ! -n $lastserverfile ]];then
            search_dir=$download_dir
            lastserverfile=$(ls "$search_dir" |grep "kylin-ide-server_[0-9]\+\.[0-9]\+\.[0-9]\+_${serverArch}.tar.gz"  |sort -V |tail -n 1)
    fi
    if grep -q "debian" /etc/os-release;then
        if [[ ! -n $lastserverfile ]];then
            #下载
            # apt download kylin-ide-server
            current_dir=$(pwd)
            cd "/tmp"||exit
            apt download ${PACKAGENAME} >/dev/null
            # cd $current_dir ||exit
            packagefile=$(ls "/tmp" |grep "kylin-ide-server-[0-9]\+\.[0-9]\+\.[0-9]\+-.*${serverArch}.rpm"  |sort -V |tail -n 1)
            if [[ ! -n $packagefile ]];then
                # return fase
                echo "download failed"
                exit 0
            fi
            cd "$download_dir"||exit
            ar x "/tmp/$packagefile"   #解压
            search_dir="${download_dir}/usr/local/kylin-ide-server"
            
        fi
        
        
    else
        if [[ ! -n $lastserverfile ]];then
            dnf download ${PACKAGENAME} --destdir=/tmp >/dev/null
            packagefile=$(ls "/tmp" |grep "kylin-ide-server-[0-9]\+\.[0-9]\+\.[0-9]\+-.*${serverArch}.rpm"  |sort -V |tail -n 1)
            if [[ ! -n $packagefile ]];then
                # return fase
                echo "download failed"
                exit 0
            fi
            rpm2cpio "/tmp/${packagefile}" |cpio -id --no-absolute-filenames -D ${download_dir}  >/dev/null
            search_dir="${download_dir}/usr/local/kylin-ide-server"
            #rm $packagefile
        fi
     fi
    #解压
    lastserverfile=$(ls "$search_dir" |grep "kylin-ide-server_[0-9]\+\.[0-9]\+\.[0-9]\+_${serverArch}.tar.gz"  |sort -V |tail -n 1)
    if [[ -n $lastserverfile ]];then
        tar -xf ${search_dir}/${lastserverfile} -C  ~/.kylin-ide-server/server #如何判断命令执行是否成功
        grep 'kylin' /etc/os-release;
        if [ $? -eq 0 ];then
            if command -v kysec_set >/dev/null 2>&1 ;then
                find  ~/.kylin-ide-server/server -name *.node -exec kysec_set -n exectl -v verified {} +;
                [ -f ~/.kylin-ide-server/server/node ] && kysec_set -n exectl -v verified ~/.kylin-ide-server/server/node;
                [ -d ~/.kylin-ide-server/server/bin ] && kysec_set -r -n exectl -v verified ~/.kylin-ide-server/server/bin;
            fi
        fi
        echo "DEPLOYSUCCESS"
        exit 0
    fi  
   
fi 
echo "deploy failed"
exit 0


