#!/bin/bash
if [ "$#" -ne 1 ];then
    echo "error"
    exit 1
fi
_browserpath=$1
# needcheck=$2
new_ref=$(echo $MY_TKNREF)
# hashkey=$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 10 | head -n 1)
hashkey=$(uuidgen|tr -d '-')
script_dir=$(dirname "$(readlink -f "$0")")
template_file="$script_dir/template.html"
tmp_html="$HOME/.kylin-ide-remote/$hashkey.html"

out=$_browserpath
get_applications_path(){
    local _path="$1"
     if [ ! -f "/usr/share/applications/$_path" ];then
        echo ""
    fi
    result=$(grep -Po '(?<=^Exec=).*' /usr/share/applications/$_path |head -1|sed -e 's/%.*//')
    echo $result
}
# isabsolute=true
# if [ "$needcheck" = true ];then
#     out=$(get_applications_path $_browserpath)
if [[ "$_browserpath" == *.desktop ]];then
    #检查文件是否存在，如果不存在则which，如果是desktop文件则需要找到对应的程序路径，desktop无法执行
    final_name=$(basename "$_browserpath")
    out=$(get_applications_path $final_name)
fi
if [ ! -f "$out" ];then
    exepath=$(which $out)
    if [ -n "$exepath" ] ;then
        out=$exepath
    else
        echo "浏览器未找到"
        exit 1
    fi
fi

if [ -z "$out" ];then
    echo "浏览器未找到"
    exit 1
fi
if [ -x "$out" ] ;then
    #if file $out |grep -q 'ELF .* executable' | [ -L "$out" ] ;then
        browsername=$(basename "$_browserpath")
        browsername=${browsername%.*}
        if [ -n "$browsername" ];then
            sed "s|{{REF}}|$new_ref|g" "$template_file" > "$tmp_html"
            chmod 600 "$tmp_html"
            configdir="$HOME/.config/"
            userdir="${browsername}-web-client"
            app_arg="file://$tmp_html"
            cmd=" $out --user-data-dir=$configdir$userdir --disable-desktop-notifications --allow-insecure-localhost --ignore-certificate-errors --test-type --no-first-run --no-default-browser-check --disable-extensions --app=$app_arg "
            # export DISPLAY=:0
            nohup $cmd &>/tmp/openbrowser.log 2>&1 &
            (sleep 10; rm $tmp_html) >/dev/null 2>&1 &
            JOB_PID=$!
            disown -h $JOB_PID
            echo "success"
            exit 0
        else
            echo "浏览器为空"
            exit 1
        fi
    #else
    #    echo "文件不是二进制或软连接" 
    #fi

else
    echo "所选文件无执行权限"
    exit 1
fi